﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;
using HeuristicLab.Problems.DataAnalysis;
using HeuristicLab.Problems.Instances.DataAnalysis.Regression.Matlab.Api;
using HeuristicLab.Problems.Instances.DataAnalysis.Regression.Matlab.Api.Types;

namespace HeuristicLab.Problems.Instances.DataAnalysis.Views.Regression.Matlab {
  public partial class RegressionMatlabImportDialog {
    private class MLDoubleArrayLoader : MLVariablesLoader {
      public MLDoubleArrayLoader(RegressionMatlabImportDialog importDialog, CheckedListBox variablesListBox) 
        : base(importDialog, variablesListBox, MLDatatype.DoubleArray) {
      }
      
      public override Dataset GetPreviewDataset(IMatlabConnector mlConnector, CancellationToken token) {
        var doubleArrays = new List<MLDoubleArray>();        

        foreach (MLVariableInfo item in _variablesListBox.CheckedItems.Cast< MLVariableInfo>().ToList()) {
          if (token.IsCancellationRequested) {
            return null;
          }

          if (item.Datatype == _mlDatatype) {
            var val = mlConnector.GetDoubleArray(item.VarName);
            if (val != null) {
              doubleArrays.Add(val);
            }
          }
        }
        var merged = MLDoubleArray.Concat(doubleArrays);
        return new Dataset(merged.DataHeader, merged.Data);
      }
    }
  }
}
